<?php
/*
Copyright 2011  Mobile Sentience LLC  (email : oss@mobilesentience.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

require_once('libs/AdsenseStats.php');
require_once('libs/SiteDB.php');
require_once('libs/Version.php');

class AdvertwhirlPlugin {
	// Implement Singleton Design Pattern
	static private $instance = null; /* The sole instance */

	private $options;

	private $adserv;
	private $prodid = "advertwhirl";
	private $version;
	private $name;

	private $pluginDir;
	private $pluginFile;
	private $pluginPage;
	private $pageURL;
	private $imagePath;
	private $libraryPath;
	private $handbookPath;

	private $adsense;
	private $db;

	private $PromoteText = '<form target="_blank" action="https://www.paypal.com/cgi-bin/webscr" method="post">Advertwhirl <input type="hidden" name="cmd" value="_s-xclick"><input type="hidden" name="hosted_button_id" value="U9SUYMTEKZJDY"><input type="image" src="https://www.paypalobjects.com/WEBSCR-640-20110306-1/en_US/i/btn/btn_donate_SM.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!"><img alt="" border="0" src="https://www.paypalobjects.com/WEBSCR-640-20110306-1/en_US/i/scr/pixel.gif" width="1" height="1"> <a target="_blank" href="http://twitter.com/#!/MobileSentience">Follow Mobile Sentience</a><iframe src="http://www.facebook.com/plugins/like.php?href=https%3A%2F%2Fwww.facebook.com%2Fpages%2FMobile-Sentience%2F184752614894685%3Fsk%3Dapp_136488953086266&amp;layout=button_count&amp;show_faces=false&amp;width=200&amp;action=like&amp;font&amp;colorscheme=light&amp;height=21" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:100px; height:21px;" allowTransparency="true"></iframe></form>';

	private $DonateImage = '<form action="https://www.paypal.com/cgi-bin/webscr" method="post"><input type="hidden" name="cmd" value="_s-xclick"><input type="hidden" name="hosted_button_id" value="U9SUYMTEKZJDY"><input type="image" src="https://www.paypalobjects.com/WEBSCR-640-20110306-1/en_US/i/btn/btn_donate_SM.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!"><img alt="" border="0" src="https://www.paypalobjects.com/WEBSCR-640-20110306-1/en_US/i/scr/pixel.gif" width="1" height="1"></form>';
	private $DonateText = '<a target="_blank" href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=U9SUYMTEKZJDY">Donate</a>';

	private $TwitterFollow = '<a target="_blank" href="http://twitter.com/#!/MobileSentience">Follow Mobile Sentience</a>';
	private $FacebookFollow = '<iframe src="http://www.facebook.com/plugins/like.php?href=https%3A%2F%2Fwww.facebook.com%2Fpages%2FMobile-Sentience%2F184752614894685%3Fsk%3Dapp_136488953086266&amp;layout=button_count&amp;show_faces=false&amp;width=200&amp;action=like&amp;font&amp;colorscheme=light&amp;height=21" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:100px; height:21px;" allowTransparency="true"></iframe>';

	private $AdminTabs = array(
		'campaigns-tab' => array('name' => 'Campaigns', 'method_base' => 'CampaignListTab'),
		'sources-tab' => array('name' => 'Local Ads', 'method_base' => 'SourceListTab'),
		'settings-tab' => array('name' => 'Settings', 'method_base' => 'SettingsTab'),
		/*'handbook-tab' => array('name' => 'Handbook', 'method_base' => 'HandbookTab'),*/
		'support-tab' => array('name' => 'Support', 'method_base' => 'SupportTab'),
		'about-tab' => array('name' => 'About', 'method_base' => 'AboutTab')
	);

	private $AllocationMap = array(
		'name' => 'alname-',
		'description' => 'aldescription-',
		'ads' => array(
			'advertisement' => 'alad-',
			'weight' => 'aladweight-',
			'percent-weight' => 'aladpercentweight-'
		),
		'rulesets' => array(
			'id' => 'alrulesetid-',
			'rules' => array(
				'type' => 'alruletype-',
				'author' => 'alruleauthor-',
				'posttype' => 'alruleposttype-',
				'tag' => 'alruletag-',
				'category' => 'alrulecategory-',
				'post' => 'alrulepost-',
				'page' => 'alrulepage-',
				'argname' => 'alruleargumentname-',
				'argvalue' => 'alruleargumentvalue-',
				'argop' => 'alruleargumentoperator-'
			)
		)
	);

	private $RuleTypes = array (
		'author' => 'Match an author',
		'posttype' => 'Match the post type',
		'getargument' => 'Match link arguments'
	);

	private $CacheTimes = array(
		'0' => 'Never Cache',
		'1' => 'Save loaded data for 1 hour',
		'24' => 'Save loaded data for 1 day',
		'168' => 'Save loaded data for 1 week'
	);

	// Protected constructor for singleton
	private function __construct(){
		/** Uncomment for testing, forces loading of plugin stylesheets and javascripts */
		global $pluginversion;
		global $pluginname;
		$this->version = $pluginversion;
		$this->name = $pluginname;
		$this->adserv = 'http://www.mobilesentience.com/ads/WordpressPlugins&plugin=' . $this->name . '&pluginversion=' . $this->version;
		$this->pluginFile = __FILE__;
		$this->pageURL = '?page=' . $this->getRightMost(__FILE__, 'plugins/');
		$this->imagePath = WP_PLUGIN_URL . '/' . str_replace(basename( __FILE__), "", plugin_basename(__FILE__)) . '/images/';
		$this->externalAdsPath = str_replace(get_site_url(), '', WP_PLUGIN_URL . '/' . str_replace(basename( __FILE__), "", plugin_basename(__FILE__))) . '/ServeAd.php?campaign=';
		if(empty($this->pluginDir)) $this->pluginDir = dirname($this->pluginFile);
		$this->libraryPath = $this->pluginDir . '/libs/';
		$this->handbookPath = $this->pluginDir . '/handbook.txt';

		$this->adsense = new AdsenseStats();
		$this->db = new SiteDB();

		//Language Setup
		$locale = get_locale();
		$mo = dirname(__FILE__) . "/languages/" . $this->name . "-".$locale.".mo";
		load_textdomain($this->name, $mo);

		add_action('init', array(&$this, 'InitializePlugin'));
	}

	public function DeactivatePlugin() {
		/* Remove the shortcodes */
		$this->RemoveShortcodes();

		/** Register Admin Style Sheet*/
		wp_deregister_style('advertwhirl-plugin-admin-css');

		/** Register Admin Javascript*/
		wp_deregister_script('advertwhirl-plugin-admin-scripts');
	}

	// Protected cloner for singleton
	private function __clone(){}

	public function InitializePlugin(){
		/* Get plugin data */
		global $wp_version;
		if ($wp_version=="2.6"){
			// 2.6 fix, this version unserializes data for some odd reason.
			$this->options = get_option($this->name . "_options");
		}else{
			$this->options = unserialize(get_option($this->name . "_options"));
		}

		/* Hook the actions */
		$this->HookActions();

		/* Add the shortcodes */
		$this->AddShortcodes();

		if (gettype($this->options)!="array"){
			$this->options = array();
		}

		if(!isset($this->options['settings']))
			$this->options['settings'] = $this->DefaultSettings();
			
		$this->adsense->SetUsername($this->options['settings']['adsense']['username']);
		$this->adsense->SetPassword($this->options['settings']['adsense']['password']);
	}

	private function DefaultSettings(){
		$settings = array();
		$settings['externalAdsEnabled'] = false;
		$settings['adUrlPrefix'] = 'advertwhirl';

		/* Default Settings for Adsense */
		$adsenseSettings = array();
		$adsenseSettings['username'] = "";
		$adsenseSettings['password'] = "";
		$adsenseSettings['ads-cache'] = 8640;
		$adsenseSettings['stats-cache'] = 8640;
		$settings['adsense'] = $adsenseSettings;

		$analyticsSettings = array();
		$analyticsSettings['enabled'] = false;
		$analyticsSettings['username'] = "";
		$analyticsSettings['password'] = "";
		$analyticsSettings['VariablesEnabled'] = true;
		$settings['analytics'] = $analyticsSettings;

		return $settings;
	}

	public function HookActions() {
        add_action('admin_menu', array(&$this, 'DisplayAdminMenu')); /* Add the admin menu */
		add_action('wp_dashboard_setup', array(&$this, 'AddDashboardWidgets')); /* Add the stats widget to the dashboard */

		add_action('generate_rewrite_rules', array(&$this, 'RewriteExternalAds'));
		add_action('admin_init', array(&$this, 'FlushRewrites'));
	}

	public function AddShortcodes(){
		add_shortcode('advertwhirl', array(&$this, 'HandleShortcode_advertwhirl'));
	}

	public function RemoveShortcodes(){
		remove_shortcode('advertwhirl', array(&$this, 'HandleShortcode_advertwhirl'));
	}

	public function FlushRewrites(){
		if($this->options['settings']['externalRulesUpdated']){
			$this->options['settings']['externalRulesUpdated'] = false;
			global $wp_rewrite;
			$wp_rewrite->flush_rules();
		}
	}

	public function RewriteExternalAds() {
		global $wp_rewrite;
		$prefix = $this->options['settings']['adUrlPrefix'];

		if($this->options['settings']['externalAdsEnabled']){
			$newRules = array(
				$prefix . '/(.*)' => $this->externalAdsPath . '$1'
			);

			$wp_rewrite->non_wp_rules = $newRules + $wp_rewrite->non_wp_rules;
		}
	}

	// Get the sole instance of the singleton
	static public function GetInstance(){
		if(self::$instance === null){
			self::$instance = new AdvertwhirlPlugin();
		}
		return self::$instance;
	}

	private function GetTechnicalSpecs(){
		global $wp_version;
		$specs .= "Plugin Specs\n";
		$specs = "========================================\n";
		$specs .= "Plugin: $this->name\n";
		$specs .= "Plugin Version: $this->version\n";
		$specs .= "Plugin Directory: $this->pluginDir\n\n";


		$specs .= "Server Specs\n";
		$specs = "========================================\n";
		$specs .= "Server Address: " . $_SERVER['SERVER_ADDR'] . "\n";
		$specs .= "Server Name: " . $_SERVER['SERVER_NAME'] . "\n";
		$specs .= "Server Software: " . $_SERVER['SERVER_SOFTWARE'] . "\n\n";

		$specs .= "Wordpress Specs\n";
		$specs = "========================================\n";
		$specs .= "Blog Name: " . get_option('blogname') . "\n";
		$specs .= "Wordpress Version: $wp_version\n";
		$specs .= "Wordpress Siteurl: " . get_option("siteurl") . "\n";
		$specs .= "Wordpress Home: " . get_option("home") . "\n";
		$specs .= "\tActive Plugins\n";
		$specs .= "\t========================================\n";
		foreach(get_option('active_plugins') as $index => $plugin){
			if(strlen($plugin)>0)
				$specs .= "\t$plugin\n";
		}

		/** PHP Info - @TODO: outputs html and needs to be parsed */
		//ob_start();
		//phpinfo(INFO_GENERAL or INFO_CONFIGURATION or INFO_MODULES);
		//$specs .= ob_get_contents();
		//ob_get_clean();

		return $specs;
	}

	function HandleShortcode_advertwhirl($atts, $content = null) {
		extract(shortcode_atts(array('campaign' => null), $atts));
		$output = 'No Campaign selected';
		if(isset($campaign)){
			$output = 'advertisement for campaign ' . $campaign;
		}
		return $output;
	}

	// Add the stats widget to the dashboard
	public function AddDashboardWidgets() {
		// Add statistics widget to dashboard
		if(isset($this->options['settings']['displayDashboard']) && $this->options['settings']['displayDashboard'])
			wp_add_dashboard_widget("AdvertwhirlStatsWidget", "Advertwhirl", array(&$this, "DisplayAdvertwhirlStatsWidget"));
	} 

	public function DisplayAdsenseStats(){
		$periods = array();
		foreach($this->adsense->GetReportPeriods() as $key => $value){
			if(isset($this->options['settings']['adsense']['period'][$key])){
				$periods[$key] = $this->options['settings']['adsense']['period'][$key];
			}else{
				$periods[$key] = false;
			}
		}

		$types = array();
		foreach($this->adsense->GetReportTypes() as $key => $value){
			if(isset($this->options['settings']['adsense']['type'][$key])){
				$types[$key] = $this->options['settings']['adsense']['type'][$key];
			}else{
				$types[$key] = false;
			}
		}

		$categories = array();
		foreach($this->adsense->GetAdCategories() as $key => $value){
			if(isset($this->options['settings']['adsense']['category'][$key])){
				$categories[$key] = $this->options['settings']['adsense']['category'][$key];
			}else{
				$categories[$key] = false;
			}
		}

		$this->adsense->LoadStats();
		$this->adsense->GetStatTables($periods, $types, $categories);
	}

	public function DisplayAdvertwhirlStatsWidget(){
		echo '<div class="wrap">';
			if($this->options['settings']['adsense']['dashboard'])
				$this->DisplayAdsenseStats();
		echo '</div>';
	}

    public function DisplayAdminMenu(){
		$this->pluginPage = add_options_page('Advertwhirl Options', 'Advertwhirl', 'manage_options', __FILE__, array(&$this, 'CreateAdminPanel'));

		add_action('admin_print_styles-' . $this->pluginPage, array(&$this, 'LinkAdminStylesheet'));
		add_action('admin_print_scripts-' . $this->pluginPage, array(&$this, 'LinkAdminScripts'));
    }

	function LinkAdminStylesheet() {
		/** Register plugin admin stylesheet*/
		wp_register_style('advertwhirl-plugin-admin-css', plugins_url('css/styles.css', __FILE__), false, $this->version);

		/** Enqueue plugin admin stylesheet*/
		wp_enqueue_style('advertwhirl-plugin-admin-css');
	}

	function LinkAdminScripts() {
		/** Register plugin admin javascript*/
		wp_register_script('advertwhirl-plugin-admin-scripts', plugins_url('advertwhirl.js', __FILE__), false, $this->version);

		/** Enqueue plugin admin stylesheet*/
		wp_enqueue_script('advertwhirl-plugin-admin-scripts');
	}

	function DisplayMobileSentienceAd(){
		echo '<iframe src="' . $this->adserv . '" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:735px; height:97px;" allowTransparency="true"></iframe>';
	}

	public function DisplayAdminBanner($activeTab){
		echo '<h2>' . $this->PromoteText . '</h2>';
	}

	function ShiftArrayElement(&$a, $index, $delta){
		if(isset($a) && is_array($a)){
			$nindex = $index + $delta;
			if($nindex < 0){
				$nindex = 0;
			}else if($nindex >= sizeof($a)){
				$nindex = sizeof($a) - 1;
			}

			$tmp = $a[$index];
			for($i = $index; $i != $nindex; $i += $delta){
				$a[$i] = $a[$i + $delta];
			}
			$a[$nindex] = $tmp;
		}


	}
	
	function ExtractPostArray($map, $postfix = ""){
		$sets = null;
		$i = 0;
		$found = true;
		while($found){
			$set = null;
			$found = false;
			foreach($map as $dkey => $pkey){
				if(is_array($pkey)){
					$post = $postfix . $i . '-';
					$sub = $this->ExtractPostArray($pkey, $post);
					if(isset($sub)){
						if(!isset($set)){
							$set = array();
						}
						$set[$dkey] = $sub;
						$found = true;
					}
				}else if(isset($_POST[$pkey . $postfix . $i])){
					if(!isset($set)){
						$set = array();
					}
					$set[$dkey] = $_POST[$pkey . $postfix . $i];
					$found = true;
				}
			}
			if(isset($set)){
				if(!isset($sets)){
					$sets = array();
				}
				$sets[] = $set;
			}
			$i++;
		}

		return $sets;
	}

	function CalculateWeights($campaign, $index, &$allocation){
		// Setup weight stats
		$success = true;
		$totalWeights = 0;
		$totalPercents = 0;
	
		$percents = array();
		foreach($allocation['ads'] as $i => $ad){
			$weight = strlen($ad['weight']) > 0?$ad['weight']:0;
			$weight = str_replace(' ', '', $weight);
			if(is_numeric($weight)){ /* Weight */
				$w = intVal($weight);
				$totalWeights += $w;
				if($w < 0){
					$_POST['aladweighterror-' . $index . '-' . $i] = "*Allocations can't have a negative weight";
					$success = false;
				}else if(isset($ad['percent-weight'])){
					unset($ad['percent-weight']);
				}
				//error_log("CalulateWeights: weight => $weight");
			}else if (strpos($weight, '%') !== false){ /* Percent */
				$weight = str_replace('%', '', $weight);
				$percents["$i"] = floatVal($weight)/100;
				if($percents["$i"] < 0){
					$_POST['aladweighterror-' . $index . '-' . $i] = "*Allocations can't have a negative weight";
					$success = false;
				}
				$totalPercents += $percents["$i"];
				//error_log("CalculateWeights percent => " . $percents["$i"]);
			}else{
				// set error code
				$_POST['aladweighterror-' . $index . '-' . $i] = "*Invalid weight value";
				//error_log("CalculateWeights => error");
				$success = false;
			}
		}
		if($totalPercents > 1 || ($totalPercents == 1 && $totalWeights > 0)){
			$_POST['aladweighterror-' . $index] = "*Ad slots over-allocated";
			$success = false;
		}else if($totalPercents < 1 && $totalWeights == 0){
			$_POST['aladweighterror-' . $index] = "*Ad slots under-allocated, percentage only allocations must total 100%";
			$success = false;
		}

		if(!$success)
			return $success;

		// Calculate percent weights
		$weightWithPercents = $totalWeights == 0 && $totalPercents > 0?1000:$totalWeights/(1 - $totalPercents);
		$percentWeightsOnly = $totalWeights == 0 && $totalPercents > 0?true:false;
		//error_log("Calculate Weights: weightWithPercents = $totalWeights / (1 - $totalPercents)");
		//error_log("Calculate Weights: total weights => $totalWeights");
		//error_log("Calculate Weights: total percents => $totalPercents");
		//error_log("Calculate Weights: weight with percents => $weightWithPercents");
		if($percentWeightsOnly){
			require_once('libs/Math.php');
			if(count($percents) == 1){
					$allocation['ads'][$i]['percent-weight'] = intval($w);
			}else{
				$values = array();
				foreach($percents as $i => $percent){
					$w = $weightWithPercents * $percent;
					$values[] = intval($w);
				}
				$gcf = get_gcf($values);
				foreach($values as $i => $value){
					$allocation['ads'][$i]['percent-weight'] =  $gcf !== false?$value / $gcf:$value;
				}
			}
		} else{
			foreach($percents as $i => $percent){
				$w = $weightWithPercents * $percent;
				$allocation['ads'][$i]['percent-weight'] = ceil($w);
				//error_log("Calculate Weights: percent weight => " . $ad['percent-weight']);
			}
		}

		unset($this->options['stats']['adcampaigns'][$campaign]['allocations'][$index]['sourceweights']);
		$this->options['stats']['adcampaigns'][$campaign]['allocations'][$index]['sourceweights'] = array();
		foreach($allocation['ads'] as $i => $ad){
			$this->options['stats']['adcampaigns'][$campaign]['allocations'][$index]['sourceweights'][] = 0;
		}

		//unset($this->options['stats']['allocations'][$aname]['sponsorweight']);
		//$this->options['stats']['allocations'][$aname]['sponsorweight'] = 0;
		return $success;
	}

	function CampaignListTab_update($tab, $action){
		// Check for allocation buttons
		$postAllocations = $this->ExtractPostArray($this->AllocationMap);
		if(isset($postAllocations) && sizeof($postAllocations) > 0){
			$edit = false;
			$count = sizeof($postAllocations);
			for($i = 0; $i < $count; $i++){
				if(isset($_POST['aldown-' . $i])){
					$this->ShiftArrayElement($postAllocations, $i, 1);
					$edit = true;
				}else if(isset($_POST['alup-' . $i])){
					$this->ShiftArrayElement($postAllocations, $i, -1);
					$edit = true;
				}else if(isset($_POST['alremove-' . $i])){
					unset($postAllocations[$i]);
					$edit = true;
				}else if(isset($_POST['add-allocation-source-' . $i])){
					$_POST['adsupdated-' . $i] = true;
					$postAllocations[$i]['ads'][] = $this->GetDefaultAllocationAd();
					$edit = true;
				}else if(isset($_POST['add-allocation-ruleset-' . $i])){
					$postAllocations[$i]['rulesets'][] = array();
					$postAllocations[$i]['rulesets'][0]['id'] = $i . '-' . sizeof($postAllocations[$i]['rulesets']);
					$edit = true;
				}
				$adcount = sizeof($postAllocations[$i]['ads']);
				for($j = 0; $j < $adcount; $j++){
					if(isset($_POST['aladremove-' . $i . '-' . $j])){
						$_POST['adsupdated-' . $i] = true;
						unset($postAllocations[$i]['ads'][$j]);
						$edit = true;
					}
				}
				for($j = 0; $j < sizeof($postAllocations[$i]['rulesets']); $j++){
					if(isset($_POST['add-allocation-rule-' . $i . '-' . $j])){
						$postAllocations[$i]['rulesets'][$j]['rules'][] = $this->GetDefaultAllocationRule($_POST['new-rule-type-' . $i . '-' . $j]);
						$edit = true;
					}
					$rulecount = sizeof($postAllocations[$i]['rulesets'][$j]['rules']);
					for($k = 0; $k < $rulecount; $k++){
						if(isset($_POST['alruleremove-' . $i . '-' . $j . '-' . $k])){
							unset($postAllocations[$i]['rulesets'][$j]['rules'][$k]);
							$edit = true;
						}
					}
				}
			}

			if($edit){
				if(isset($_POST['current-action'])){
					$action = $_POST['current-action'];
				}
				if(isset($_POST['add-set']) && $_POST['add-set']){
					$_POST['add'] = true;;
				}
				if(isset($_POST['edit-set']) && $_POST['edit-set']){
					$_POST['edit'] = true;;
				}
				return $this->CampaignListTab_edit($tab, $action, $postAllocations);
			}
		}

		if(isset($_POST['current-action'])){
			$action = $_POST['current-action'];
		}
		if(isset($_POST['add-set']) && $_POST['add-set']){
			$_POST['add'] = true;;
		}
		if(isset($_POST['edit-set']) && $_POST['edit-set']){
			$_POST['edit'] = true;;
		}

		if(isset($_POST['add-allocation'])){
			$postAllocations[] = $this->GetDefaultAllocation();

			return $this->CampaignListTab_edit($tab, $action, $postAllocations);
		} else if(isset($_POST['add'])){
			if(!isset($_POST['name']) || $_POST['name'] == ""){
				$_POST['name_error'] = "*Name is a required field";
				return $this->CampaignListTab_edit($tab, $action);
			}
			$name = $_POST['name'];

			$error = false;
			foreach($postAllocations as $i => $allocation){
				$error = $this->CalculateWeights($name, $i, $allocation)?$error:true;
			}
			if($error){
				return $this->CampaignListTab_edit($tab, $action);
			}

			$this->options['adcampaigns'][$name]['allocations'] = $postAllocations;
			$this->options['adcampaigns'][$name]['description'] = $_POST['description'];

			update_option($this->name . "_options", serialize($this->options));
			return $this->CampaignListTab_view($tab, $action);
		} else if(isset($_POST['update'])){
			if(!isset($_POST['name']) || $_POST['name'] == ""){
				$_POST['name_error'] = "*Name is a required field";
				return $this->CampaignListTab_edit($tab, $action);
			}

			$name = $_POST['name'];
			if(isset($this->options['adcampaigns'][$name]) && $_POST['origname'] != $name){
				$_POST['name_error'] = "*Name must be unique";
				return $this->CampaignListTab_edit($tab, $action);
			}

			$error = false;
			foreach($postAllocations as $i => &$allocation){
				if(!$_POST['adsupdated-' . $i]){
					foreach($allocation['ads'] as $j => $ad){
						if($_POST['aladoriginalweight-' . $i . '-' . $j] != $ad['weight']){
							$error = $this->CalculateWeights($name, $i, $allocation)?$error:true;
							break;
						}
					}
				}else{
					$error = $this->CalculateWeights($name, $i, $allocation)?$error:true;
				}
			}

			if($error){
				return $this->CampaignListTab_edit($tab, $action);
			}

			if($_POST['origname'] != $name){
				$oname = $_POST['origname'];
				unset($this->options['adcampaigns'][$oname]);
				unset($this->options['stats']['adcampaigns'][$oname]);
			}

			$this->options['adcampaigns'][$name]['allocations'] = $postAllocations;
			$this->options['adcampaigns'][$name]['description'] = $_POST['description'];

			update_option($this->name . "_options", serialize($this->options));
			return $this->CampaignListTab_view($tab, $action);
		} else if(isset($_POST['delete'])){
			if(!isset($_POST['name']) || $_POST['name'] == ""){
				return $this->CampaignListTab_view($tab, $action);
			}
			$name = $_POST['name'];
			unset($this->options['adcampaigns'][$name]);
			update_option($this->name . "_options", serialize($this->options));
			return $this->CampaignListTab_view($tab, $action);
		} else if(isset($_POST['cancel'])){
			return $this->CampaignListTab_view($tab, $action);
		}
	}

	function GetAllocationRuleForm_author($i, $j, $k, $rule){
		$authors = $this->db->GetAuthorsList();
		$content .= '
																			<select name="alruleauthor-' . $i . '-' . $j . '-' . $k . '" style="width:99%;" >';

		foreach($authors as $id => $author){
			$selected = $rule['author'] == $id?"selected":"";
			$content .= '
																				<option value="' . $id . '" ' . $selected . '>' . $author['lastname'] . ', ' . $author['firstname'] . '</option>';
		}
		$content .= '
																			</select>';
		return $content;
	}

	function GetAllocationRuleForm_posttype($i, $j, $k, $rule){
		$content .= '
																			<select name="alruleposttype-' . $i . '-' . $j . '-' . $k . '" style="width:99%;">';

		$post_types=get_post_types('','names'); 
		foreach ($post_types as $type ) {
			$selected = $rule['posttype'] == $type?"selected":"";
			$content .= '
																				<option value="' . $type . '" ' . $selected . '>' . $type . '</option>';
  		}
		$content .= '
																			</select>';
		return $content;
	}

	function GetAllocationRuleForm_getargument($i, $j, $k, $rule){
		$argumentOperators = array (
			'=' => 'is equal to',
			'!=' => 'is not equal to',
			'>' => 'is greater than',
			'<' => 'is less than',
			'>=' => 'is greater than or equal to',
			'<=' => 'is less than or equal to',
			'~' => 'matches regular expression',
			'!~' => 'does not match regular expression',
		);

		$content .= '
																			<label for="alruleargumentname-' . $i . '-' . $j . '-' . $k . '">Argument</label><input type="text" name="alruleargumentname-' . $i . '-' . $j . '-' . $k . '" value="'. $rule['argname'] . '" />';
		$content .= '
																			<select name="alruleargumentoperator-' . $i . '-' . $j . '-' . $k . '" >';

		foreach ($argumentOperators as $value => $label) {
			$selected = $rule['argop'] == $value?"selected":"";
			$content .= '
																				<option value="' . $value . '" ' . $selected . '>' . $label . '</option>';
  		}

		$content .= '
																			</select>
																			<input type="text" name="alruleargumentvalue-' . $i . '-' . $j . '-' . $k . '" value="'. $rule['argvalue'] . '" />';

		return $content;
	}

	function GetAllocationRuleForm($i, $j, $k, $rule){
		$func = "GetAllocationRuleForm_" . $rule['type'];
		if(method_exists($this, $func)){
			$content = '
															<tr class="gradient2">
																<th scope="col" nowrap>' . $this->RuleTypes[$rule['type']] . '</th>
																	<td valign="middle" style="width:1%;" nowrap>
																		<input type="hidden"  name="alruletype-' . $i . '-' . $j . '-' . $k . '" value="' . $rule['type'] . '"/>';

			$content .= call_user_func(array(&$this, $func), $i, $j, $k, $rule);

			$content .= '
																		</td>
																		<td align="left" style="width:1%" nowrap>
																			<input type="submit" class="button" name="alruleremove-' . $i . '-' . $j . '-' . $k . '" value="Remove" />
																		</td>
																	</tr>';
		}

		return $content;
	}

	function GetAllocationAdForm($i, $index, $ad, $displayRemove){
		if($displayRemove){
			$labelWidth = "10%";
			$adWidth = "40%";
			$weightWidth = "20%";
		}else{
			$labelWidth = "10%";
			$adWidth = "50%";
			$weightWidth = "30%";
		}
		$content .= ' 
							<tr class="gradient4">
								<td colspan="2">
									<table id="aladform-' . $i . '-' . $index . '" width="100%">
										<tr class="gradient2">
											<th scope="col" style="width:' . $labelWidth . ';" nowrap="nowrap">Ad Source</th>
											<td valign="middle" style="width:' . $adWidth . ';">
												<select name="alad-' . $i . '-' . $index . '" style="width:99%;">';
		foreach($this->options['adsources'] as $name => $source){
			if($name == $ad['advertisement']){
				$content .= '
													<option value="' . $name .'" selected>local ad - ' . $name . '</option>' . "\n";
			}else{
				$content .= '
													<option value="' . $name .'" >local ad - ' . $name . '</option> . "\n"';
			}
		}

		if(isset($this->options['settings']['adsense']['username']) && isset($this->options['settings']['adsense']['password'])){
				$this->adsense->LoadAdUnits();
				$adUnits = $this->adsense->GetAdUnits();
				if(isset($adUnits) && sizeof($adUnits) > 0){
					foreach($adUnits as $id => $unit){
						if ('adsense-' . $id == $ad['advertisement']){
							$content .= '
													<option value="adsense-' . $id .'" selected>adsense ad - ' . $unit['name'] . ' - ' .  $unit['size'] . ' ' . $unit['format'] . '</option>';
						}else{
							$content .= '
													<option value="adsense-' . $id .'" >adsense ad - ' . $unit['name'] . ' - ' .  $unit['size'] . ' ' . $unit['format'] . '</option>';
						}
					}
				}
		}


		$origweight = isset($_POST['aladoriginalweight-' . $i . '-' . $index])?$_POST['aladoriginalweight-' . $i . '-' . $index]:$ad['weight'];
		$percentweight = isset($_POST['aladoriginalweight-' . $i . '-' . $index])?$_POST['aladoriginalweight-' . $i . '-' . $index]:$ad['weight'];

		$content .= '
												</select>
											</td>
											<th scope="col" style="width:' . $labelWidth . ';">Weight</th>
											<td valign="middle" style="width:' . $weightWidth . ';">
												<input name="aladoriginalweight-' . $i . "-" . $index . '" type="hidden" value="' . $origweight . '" style="width:99%;"/>
												<strong> ' . $_POST['aladweighterror-' . $i . '-' . $index] . '</strong><input name="aladweight-' . $i . "-" . $index . '" type="text" value="' . $ad['weight'] . '" style="width:99%;"/>';
	if(isset($ad['percent-weight'])){
		$content .= '
												<input name="aladpercentweight-' . $i . "-" . $index . '" type="hidden" value="' . $ad['percent-weight'] . '" />';
	}

	$content .= '
											</td>';
			if($displayRemove){
				$content .= '
											<td valign="middle" style="width:20%;" align="center">
												<input type="submit" class="button" name="aladremove-' . $i . '-' . $index . '" value="Remove" />
											</td>';
			}
			$content .= '
										</tr>
									</table>
								</td>
							</tr>';
		return $content;
	}

	function GetAllocationForm($i, $allocation, $totalAllocations){
		// Calculate what buttons if any to display
		$displayButtonRow = $totalAllocations > 1;
		$displayMoveUp = $i > 0;
		$displayMoveDown = $i < $totalAllocations - 1;
		$adsupdated = isset($_POST['adsupdated-' . $i])?$_POST['adsupdated-' . $i]:false;


		$id = $i + 1;
		$content = '
			<tr class="gradient3">
				<th><div>' . $id . '</div></th>
				<td style="width:99%;" colspan="2">
					<table width="100%" id="alform-' . $i . '">
						<tbody>
							<tr class="gradient2">
								<th scope="col" style="width:1%">Description</th>
								<td valign="middle">
									<input name="aldescription-' . $i . '" type="text" value="' . $allocation['description'] . '" style="width:99%;"/>
									<input name="adsupdated-' . $i . '" type="hidden" value="' . $adsupdated . '"/>
								</td>
							</tr>
							<!--<tr class="gradient2">
								<td colspan="2"></td>
							</tr>-->
							<tr class="gradient2">
								<th style="text-align:center;" colspan="2">Ads</th>
							</tr>';

		if(isset($_POST['aladweighterror-' . $i])){
			$content .= '
							<tr class="gradient2">
								<td colspan="2"><strong>' . $_POST['aladweighterror-' . $i] . '</strong></td>
							</tr>';
		}

		if(isset($allocation['ads'])){
			foreach($allocation['ads'] as $index => $ad){
				$content .= $this->GetAllocationAdForm($i, $index, $ad, sizeof($allocation['ads']) > 1);
			}
		}

		$content .= '
							<tr class="gradient2">
								<td align="center" colspan="2">
									<input type="submit" class="button" name="add-allocation-source-' . $i . '" value="Add Advertisement Source" />
								</td>
							</tr>
							<!--<tr class="gradient2">
								<td colspan="2"></td>
							</tr>-->
							<tr class="gradient2">
								<th style="text-align:center;" colspan="2">Rules</th>
							</tr>';

		if(isset($allocation['rulesets'])){
			$content .= '
							<tr>
								<td colspan="2">
									<table id="alrulesets-' . $i . '" width="100%">
										<tbody>';
			foreach($allocation['rulesets'] as $id => $set){
				$content .= '
											<tr class="gradient4">
												<th><div> ' . ($id + 1) . '</div></th>
												<td style="width:99%;" colspan="2">
													<input type="hidden" value="' . $set['id'] . '" name="alrulesetid-' . $i . '-' . $id .'"/>
													<table id="alrulesets-' . $i . '-' . $id .'" width="100%">
														<tbody>';
				if(isset($set['rules'])){
					foreach($set['rules'] as $j => $rule){
						$content .= $this->GetAllocationRuleForm($i, $id, $j, $rule);
					}
				}

				$content .= '
															<tr class="gradient2">
																<td align="center" colspan="3">
																	<select name="new-rule-type-' . $i . '-' . $id . '">';

				foreach($this->RuleTypes as $value => $name){
					$content .= '
																		<option value="' . $value . '">' . $name . '</option>';
				}

			$content .= '
																	</select>
																	<input type="submit" class="button" name="add-allocation-rule-' . $i . '-' . $id . '" value="Add Rule" />
																</td>
															</tr>
														</tbody>
													</table>
												</td>
											</tr>';
			}

			$content .= '
										</tbody>
									</table>
								</td>
							</tr>';
		}

		$content .= '
							<tr class="gradient2">
								<td align="center" colspan="2">
									<input type="submit" class="button" name="add-allocation-ruleset-' . $i . '" value="Add Rule Set" />
								</td>
							</tr>';
		if($displayButtonRow){
			$content .= '
							<tr class="gradient2">
								<td align="center" colspan="2">';
			if($displayMoveDown){
				$content .= '
									<input type="submit" button class="button" name="aldown-' . $i . '" value="Move Down" />';
			}

			if($displayMoveUp){
				$content .= '
									<input type="submit" class="button" name="alup-' . $i . '" value="Move Up" />';
			}

			$content .= '
									<input type="submit" class="button" name="alremove-' . $i . '" value="Remove" />
								</td>
							</tr>';
		}

		$content .= '
						</tbody>
					</table>
				</td>
			</tr>';
		return $content;
	}

	function GetDefaultAllocationRule($type = null){
		$rule = array();
		$rule['type'] = $type;
		$rule['author'] = "";
		$rule['posttype'] = "";
		$rule['tag'] = "";
		$rule['category'] = "";
		$rule['post'] = "";
		$rule['page'] = "";
		return $rule;
	}

	function GetDefaultAllocationAd(){
		$ad = array();
		$ad['advertisement'] = "";
		$ad['weight'] = "1";
		return $ad;
	}

	function GetDefaultAllocation(){
		$allocation = array();
		$allocation['name'] = "";
		$allocation['description'] = "";
		$allocation['ads'][] = $this->GetDefaultAllocationAd();
		return $allocation;
	}

	function CampaignListTab_edit($tab, $action, $postAllocations = null){
		$baseurl = $this->pageURL . '&tab=' . $tab . '&action=';
		$cancelurl = $this->pageURL . '&tab=' . $tab . '&action=view';
		//verify data
		$add = isset($_POST['add']);
		$addAllocation = isset($_POST['add-allocation']);
		$edit = isset($_POST['edit']);
		$delete = isset($_POST['delete']);
		if ($add){
			$title = "Create new ad campaign";
			$submitName = "add";
			$submitValue = "Save Campaign";
			$origname = "";
			
			if(isset($_POST['name'])){
				$name = $_POST['name'];
			}

			if(isset($_POST['description'])){
				$description = $_POST['description'];
			}
		}else if($edit){
			$title = "Edit ad campaign";
			$name = $_POST['name'];
			$submitName = "update";
			$submitValue = "Save Campaign";

			if(isset($_POST['origname'])){
				$origname = $_POST['origname'];
			}else{
				$origname = $name;
			}

			if(isset($_POST['description'])){
				$description = $_POST['description'];
			}else{
				if(isset($_POST['origname'])){
					$description = $this->options['adcampaigns'][$origname]['description'];
				}else{
					$description = $this->options['adcampaigns'][$name]['description'];
				}
			}

		} else if($delete){
			return $this->CampaignListTab_update($tab, $action);
		}

		echo
'<div class="wrap">
	<br class="clear" />
	<form action="' . $baseurl . 'update" method="post">';
	echo '
	<input name="current-action" type="hidden" value="' . $action . '"/>
	<input name="add-set" type="hidden" value="' . $add . '"/>
	<input name="edit-set" type="hidden" value="' . $edit . '"/>
	<input name="origname" type="hidden" value="' . $origname . '"/>
	<table class="widefat">
		<thead>
			<tr class="gradient">
				<th colspan="3" scope="col" style="text-align:center;">' . $title . '</th>
			</tr>
		</thead>
		<tbody id="campaign-detail" >
			<tr class="gradient2">
				<th scope="col" style="width:1%" colspan="2">Name</th>
				<td valign="middle"><strong>' . $_POST['name_error'] . '</strong><input name="name" type="text" value="' . $name . '" style="width:99%;"/></td>
			</tr>
			<tr class="gradient2">
				<th scope="col" style="width:1%" colspan="2">Description</th>
				<td valign="middle"><input name="description" type="text" value="' . $description . '" style="width:99%;"/></td>
			</tr>
			<tr class="gradient">
				<th colspan="3" scope="col" style="text-align:center;">Advertisement Allocation Schedules</th>
			</tr>';

		if(!isset($postAllocations)){
			$postAllocations = $this->ExtractPostArray($this->AllocationMap);
		}

		if(!isset($postAllocations)){
			$list = $this->options['adcampaigns'][$name]['allocations'];
		}else{
			$list = $postAllocations;
		}
		
		if(sizeof($list) == 0){
			$list[0] = $this->GetDefaultAllocation();
		}

		foreach($list as $index =>  $allocation){
			echo $this->GetAllocationForm($index, $allocation, sizeof($list));
		}

		echo '
			<tr class="gradient2">
				<td align="center" colspan="3"><input type="submit" class="button" name="add-allocation" value="Add Allocation" /></td>
			</tr>
			<tr class="gradient2">
				<td align="center" colspan="3"><input type="submit" button class="button" name="cancel" value="Cancel" /><input type="submit" class="button" name="' . $submitName . '" value="' . $submitValue . '" /></td>
			</tr>
		</tbody>
	</table>
	</form>
</div>';

	}

	function CampaignListTab_view($tab, $action){
		// Create the  Custom variable list
		$baseurl = $this->pageURL . '&tab=' . $tab . '&action=';
		echo
		'<div class="wrap">
				<br class="clear" />
				<table class="widefat">
					<thead>
						<tr class="gradient">
							<th scope="col">Name</th>
							<th scope="col">Description</th>
							<th scope="col">Action</th>
						</tr>
					</thead>
					<tbody id="the-list" class="list:url">';
		if(isset($this->options['adcampaigns'])){
			$i=0;
			foreach($this->options['adcampaigns'] as $key => $value){
				echo '<form action="' . $baseurl . 'edit" method="post">';
				echo'<tr id="' . $key .'" ';
				if (!fmod($i,2)){
					echo 'class="alternate">';
				}else{
					echo '>';
				}
				echo
				'	<td valign="middle"><input name="name" type="hidden" value="' . $key . '" />' . $key . '</td>
					<td valign="middle">' . $this->options['adcampaigns'][$key]['description'] . '</td>
					<td>
							<input type="submit" value="Edit" name="edit" class="button" />
							<input type="submit" value="Delete" name="delete" class="button-secondary delete" onClick="return confirmDeleteSource(\'' . $key . '\');" />
					</td>
				</tr></form>';
				$i++;
			}
		}
		echo'<tr id="new" ';
			if (!fmod($i,2)){
				echo 'class="alternate">';
			}else{
				echo '>';
		}
		echo '
		<form action="' . $baseurl . 'edit" method="post">
			<td align="center" colspan="3"><input type="submit" class="button" name="add" value="Add Campaign" /></td></form>
		</tr>
		</tbody></table></div>';
	}

	function SourceListTab_update($tab, $action){
		//verify data
		if($_POST['cancel']){
			return $this->SourceListTab_view($tab, $action);
		}
		$add = isset($_POST['add']);
		$delete = isset($_POST['delete']) && isset($_POST['name']) && isset($this->options['adsources'][$_POST['name']]);
		$update = isset($_POST['edit']) && isset($_POST['name']) && isset($this->options['adsources'][$_POST['name']]);

		if ($add){
			if(!isset($_POST['name']) || strlen($_POST['name']) < 1 ){
				$_POST['name_error'] = '*Name required';
				return $this->SourceListTab_edit($tab, $action);
			}
			if(isset($this->options['adsources'][$_POST['name']])){
				$_POST['name_error'] = '*Name must be unique';
				return $this->SourceListTab_edit($tab, $action);
			}
		}
		
		if($delete){
			$name = $_POST['name'];
			unset($this->options['adsources'][$name]);

			update_option($this->name . "_options", serialize($this->options));
			echo '<H1>Deleted Source ' . $name . '</H1>';
		}else{
			$name = $_POST['name'];
			$this->options['adsources'][$name]['adtype'] = $_POST['adtype'];
			if($this->options['adsources'][$name]['adtype'] == "url"){
				$this->options['adsources'][$name]['url'] = $_POST['url'];
				$this->options['adsources'][$name]['wrap_url'] = isset($_POST['wrap_url']);
				$this->options['adsources'][$name]['code'] = "";
			} else {
				$this->options['adsources'][$name]['url'] = "";
				$this->options['adsources'][$name]['wrap_url'] = false;
				$this->options['adsources'][$name]['code'] = stripslashes($_POST['code']);
			}
			$this->options['adsources'][$name]['description'] = $_POST['description'];

			update_option($this->name . "_options", serialize($this->options));
			if($add){
				echo '<H1>Added Source ' . $name . '</H1>';
			}else{
				echo '<H1>Updated Source ' . $name . '</H1>';
			}
		}

		$_POST['name'] = '';
		$_POST['adtype'] = '';
		$_POST['url'] = '';
		$_POST['wrap_url'] = '';
		$_POST['code'] = '';
		$_POST['description'] = '';

		//add to options
		return $this->SourceListTab_view($tab, $action);
	}

	function SourceListTab_edit($tab, $action){
		$baseurl = $this->pageURL . '&tab=' . $tab . '&action=';
		$cancelurl = $this->pageURL . '&tab=' . $tab . '&action=view';
		//verify data
		$add = isset($_POST['add']);
		$edit = isset($_POST['edit']);
		$delete = isset($_POST['delete']);
		if ($add){
			$title = "Create new ad source";
			$urlChecked = "checked";
			$codeChecked = "";
			$displayURL = "";
			$displayCode = "none";
			$submitName = "add";
			$submitValue = "Add Source";
		}else if($edit){
			$title = "Edit ad source";
			$name = $_POST['name'];
			$urlChecked = $this->options['adsources'][$name]['adtype'] == "url"?"checked":"";
			$codeChecked = $this->options['adsources'][$name]['adtype'] == "inline"?"checked":"";
			$displayURL = $this->options['adsources'][$name]['adtype'] == "url"?"":"none";
			$displayCode = $this->options['adsources'][$name]['adtype'] == "inline"?"":"none";
			$submitName = "edit";
			$submitValue = "Edit Source";

			$description = $this->options['adsources'][$name]['description'];
			$url = $this->options['adsources'][$name]['url'];
			$wrapURL = isset($this->options['adsources'][$name]['wrap_url'])?"checked":"";
			$code = $this->options['adsources'][$name]['code'];
		} else if($delete){
			return $this->SourceListTab_update($tab, $action);
		}
		echo
		'<div class="wrap">
				<br class="clear" />
				<table class="widefat">
					<thead>
						<tr class="gradient">
							<th style="text-align:center" scope="col" colspan="2">' . $title . '</th>
						</tr>
					</thead>
					<form id="editform" action="' . $baseurl . 'update" method="post">
					<tbody id="source-detail">
						<tr class="gradient2">
							<th scope="col" style="width:1%">Name</th>
							<td valign="middle"><strong>' . $_POST['name_error'] . '</strong><input name="name" type="text" value="' . $name . '" style="width:99%;"/></td>
						</tr>
						<tr class="gradient2">
							<th scope="col" style="width:1%">Description</th>
							<td valign="middle"><input name="description" type="text" value="' . $description . '" style="width:99%;"/></td>
						</tr>
						<tr class="gradient2">
							<th scope="col" style="width:1%">Add Type</th>
							<td valign="middle"><input type="radio" name="adtype" value="url" onClick="toggleDisplayedRows(\'url-row\', \'inline-code-row\');" ' . $urlChecked . ' >URL <input type="radio" name="adtype" value="inline" onClick="toggleDisplayedRows(\'inline-code-row\', \'url-row\');" ' . $codeChecked . ' >Inline Code</td>
						</tr>
						<tr class="gradient2" id="url-row" style="display:' . $displayURL . ';">
							<th scope="col" style="width:1%">URL</th>
							<td valign="middle" nowrap><input type="checkbox" name="wrap_url" value="1" ' . $wrapURL . '/><label>Wrap in iframe</label><input name="url" type="text" value="' . $url . '" style="width:90%;" /></td>
						</tr>
						<tr class="gradient2" id="inline-code-row" style="display:' . $displayCode . ';">
							<th valign="top" scope="col" style="width:1%" >Inline Code</th>
							<td><textarea rows="20" cols="80" name="code" >' . $code . '</textarea></td>
						</tr>
						<tr class="gradient2">
							<td align="center" colspan="2"><input type="submit" button class="button" name="cancel" value="Cancel" /><input type="submit" class="button" name="' . $submitName . '" value="' . $submitValue . '" /></td></form>
						</tr>
					</tbody>
				</table>
			</div>';
		//add to options
		//$this->SourceListTab_view($tab, $action);
	}

	function SourceListTab_view($tab, $action){
		// Create the  Custom variable list
		$baseurl = $this->pageURL . '&tab=' . $tab . '&action=';
		echo
		'<div class="wrap">
				<br class="clear" />
				<table class="widefat">
					<thead>
						<tr class="gradient" style="text-align:center;">
							<th scope="col">Name</th>
							<th scope="col">Description</th>
							<th scope="col">Action</th>
						</tr>
					</thead>
					<tbody id="the-list" class="list:url">';
		if(isset($this->options['adsources'])){
			$i=0;
			foreach($this->options['adsources'] as $key => $value){
				echo '<form action="' . $baseurl . 'edit" method="post">';
				echo'<tr valign="middle" id="' . $key .'" ';
				if (!fmod($i,2)){
					echo 'class="alternate">';
				}else{
					echo '>';
				}
				echo
				'	<td valign="middle" style="width:1%;" nowrap><input name="name" type="hidden" value="' . $key . '" />' . $key . '</td>
					<td valign="middle"><input name="description" type="text" value="' . $this->options['adsources'][$key]['description'] . '" style="width:99%;"/></td>
					<td style="width:1%;" nowrap>
							<input type="submit" class="button" name="edit" value="Edit" />
							<input type="submit" value="Delete" name="delete" class="button-secondary delete" onClick="return confirmDeleteSource(\'' . $key . '\');" />
					</td>
				</tr></form>';
				$i++;
			}
		}
		echo'<tr id="new" ';
			if (!fmod($i,2)){
				echo 'class="alternate">';
			}else{
				echo '>';
		}
		echo
		'<form action="' . $baseurl . 'edit" method="post">
			<td align="center" colspan="3"><input type="submit" class="button" name="add" value="Add Source" /></td></form>
		</tr>
		</tbody></table></div>';
	}

	function DisplaySettingsGroup($name, $content, $open){
		$ps = $open?'':'style="display:none;"';
		$chevron = $open?'collapse.gif':'expand.gif';

		echo '<div class="settingspanel"><div class="settingspanelcaption" style="height:20px; cursor: pointer;" onclick="togglePannelAnimatedStatus(this.nextSibling, 50, 50)"><div style="float: left">' . $name . '</div><div style="float: right; vertical-align: middle"><img src="' . $this->imagePath . '/'. $chevron . '" width="13" height="14" border="0" alt="Show/Hide" title="Show/Hide" /></div></div><div class="settingspanelcontent" ' . $ps . '>' . $content . '</div></div>' . "\n";

	}

	function GetAdsenseAdminForm(){
		$content =
'<table class="widefat">
	<tbody id="adsense-settings">
		<tr class="gradient2">
			<th scope="col" colspan="5" style="text-align:center;">Adsense Login</th>
		</tr>
		<tr class="gradient2">
			<th scope="col" style="width:1%;" colspan="2">Username</th>
			<td><input type="text" name="adsenseUsername" value="'. $this->options['settings']['adsense']['username'] . '" style="width:99%;"></td>
			<th scope="col" style="width:1%;">Password</th>
			<td><input type="password" name="adsensePassword" value="" autocomplete="off" style="width:99%;"></td>
		</tr>
		<tr>
			<th scope="col" colspan="5" style="text-align:center;"></th>
		</tr>
		<tr class="gradient2">
			<th scope="col" colspan="5" style="text-align:center;">Caching</th>
		</tr>
		<tr class="gradient2">
			<td colspan="5">
				<div style="text-align:left !important;">How long should Advertwhirl save data it loads from Adsense.  Loading data such as reports and ad lists can be slow, turning on caching will make the Advertwhirl control panels more responsive but new settings made at the Adsense website will not be seen immediatly by Advertwhirl.  Ad code from is always cached to insure ads are served as quickly as possible.  If you make a change to an Adsense Ad Slot that you are using as an ad source you will need to manually update the adsense cache.</div>
			</td>
		</tr>
		<tr class="gradient2">
			<th scope="col" colspan="2" >Ad Caching</th>
			<td colspan="3">
				<select name="adsense-ads-cache-time">';
		$cacheTime = isset($this->options['settings']['adsense']['ads-cache'])?$this->options['settings']['adsense']['ads-cache']:24;
		foreach($this->CacheTimes as $value => $name){
			$selected = $cacheTime == $value?"selected":"";
			$content .= '
					<option value="' . $value . '" ' . $selected . '>' . $name . '</option>';
		}

		$content .= '
				</select>
				<input type="submit" class="button" name="reload-adsense-ads-cache" value="Manually Reload Ad Units" />
			</td>
		</tr> 
		<tr class="gradient2">
			<th scope="col" colspan="2" >Reports Caching</th>
			<td colspan="3">
				<select name="adsense-stats-cache-time">';
		$cacheTime = isset($this->options['settings']['adsense']['stats-cache'])?$this->options['settings']['adsense']['stats-cache']:24;
		foreach($this->CacheTimes as $value => $name){
			$selected = $cacheTime == $value?"selected":"";
			$content .= '
					<option value="' . $value . '" ' . $selected . '>' . $name . '</option>';
		}

		$content .= '
				</select>
				<input type="submit" class="button" name="reload-adsense-stats-cache" value="Manually Reload Reports" />
			</td>
		</tr>
		<tr>
			<th scope="col" colspan="5" style="text-align:center"></th>
		</tr>
		<tr class="gradient2">
			<th scope="col" colspan="5" style="text-align:center">Adsense Reports</th>
		</tr>
		<tr class="gradient2">
			<th colspan="2" scope="col" style="width:1%;" nowrap>Get reports for</th>
			<td colspan="4">';

		foreach($this->adsense->GetReportPeriods() as $key => $value){
			$checked = $this->options['settings']['adsense']['period'][$key]?'checked':'';
			$content .= '
				<input type="checkbox" name="adsense_report_period_' . $key . '" value="' . $value . '" ' . $checked . ' /><label>' . $value . '</label>';
		}

		$content .= '
			</td>
		</tr>
		<tr class="gradient2">
			<th colspan="2" scope="col" style="width:1%;" nowrap>Statistics to report</th>
			<td colspan="4">';

		foreach($this->adsense->GetReportTypes() as $key => $value){
			$checked = 	$this->options['settings']['adsense']['type'][$key]?'checked':'';
			$content .= '
				<input type="checkbox" name="adsense_report_type_' . $key . '" value="' . $value . '" ' . $checked . ' /><label>' . $value . '</label>';
		}

		$content .= '
			</td>
		</tr>
		<tr class="gradient2">
			<th colspan="2" scope="col" style="width:1%;" nowrap>Get statistics for ad categories</th>
			<td colspan="4">';

		foreach($this->adsense->GetAdCategories() as $key => $value){
			$checked = 	$this->options['settings']['adsense']['category'][$key]?'checked':'';
			$content .= '
				<input type="checkbox" name="adsense_report_category_' . $key . '" value="' . $value . '" ' . $checked . ' /><label>' . $value . '</label>';
		}

		$content .= '
			</td>
		</tr>
		<tr><td colspan="5"><input type="submit" class="button" name="update" value="Update" /></td></tr>
	</tbody>
</table>' . "\n";
	return $content;
	}

	function GetGeneralSettingsAdminForm(){
		$fillAllocation = $this->options['settings']['fillEmptyAllocations']?"checked":"";
		$displayDashboard = $this->options['settings']['displayDashboard']?"checked":"";
		$adsenseDashboard = $this->options['settings']['adsense']['dashboard']?'checked':'';
		$externalAdsEnabled = $this->options['settings']['externalAdsEnabled']?"checked":"";
		$adUrlPrefix = $this->options['settings']['adUrlPrefix'];
		$gaEnabled = $this->options['settings']['analytics']['enabled'] && strlen($this->options['settings']['analytics']['username']) > 0 && strlen($this->options['settings']['analytics']['password']) > 0?"":"disabled";
		$gaVariablesEnabled = $this->options['settings']['analytics']['VariablesEnabled']?"checked":"";

		$content =
'<table class="widefat">
	<thead>
		<tr class="gradient2">
			<th scope="col" colspan="4" style="text-align:center;">Ad Sources</th>
		</tr>
	</thead>
	<tbody id="adsense-settings">
		<tr class="gradient2">
			<th scope="col" style="width:1%;" nowrap>Empty Sources</th>
			<td nowrap style="width:1%;"><input type="checkbox" name="fillEmptyAllocations" value="'. $this->options['settings']['fillEmptyAllocations'] . '" ' . $fillAllocation . '/><label>Fill empty ad slots with Adsource</label></td>
			<td colspan="2">
				<select name="defaultsource" style="width:99%;">
					<option value="">Select default ad source</option>' . "\n";;
		foreach($this->options['adsources'] as $name => $source){
			if ($name == $this->options['settings']['defaultsource']){
				$content .= '					<option value="' . $name .'" selected>local ad - ' . $name . '</option>' . "\n";
			}else{
				$content .= '					<option value="' . $name .'" >local ad - ' . $name . '</option> . "\n"';
			}
		}

		if(isset($this->options['settings']['adsense']['username']) && isset($this->options['settings']['adsense']['password'])){
			$this->adsense->LoadAdUnits();
			$adUnits = $this->adsense->GetAdUnits();
			if(isset($adUnits) && sizeof($adUnits) > 0){
				foreach($adUnits as $id => $ad){
					if ('adsense-' . $id == $this->options['settings']['defaultsource']){
						$content .= '					<option value="adsense-' . $id .'" selected>adsense ad - ' . $ad['name'] . ' - ' .  $ad['size'] . ' ' . $ad['format'] . '</option>' . "\n";
					}else{
						$content .= '					<option value="adsense-' . $id .'" >adsense ad - ' . $ad['name'] . ' - ' .  $ad['size'] . ' ' . $ad['format'] . '</option> . "\n"';
					}
				}
			}
		}

		$content .= '
				</select>
			</td>
		</tr>
		<tr><td colspan="4"></td></tr>
		<tr class="gradient2">
			<th scope="col" colspan="4" style="text-align:center;">External Ads</th>
		</tr>
		<tr class="gradient2">
			<td colspan="4">
				<div style="text-align:left !important;">Ad campaigns can be accessed from external sites with a permalink style url if external ads are enabled.  As these ads are being loaded outside of your wordpress site any of the rules which rely on wordpress variables, posts, pages etc... will be marked false.  Even if the external site is also running wordpress, all wordpress rules will be marked false. </div>
			</td>
		</tr>
		<tr class="gradient2">
			<th scope="col" style="width:1%;" nowrap>Enable External Ads</th>
			<td style="text-align:left">
				<input type="checkbox" name="externalAdsEnabled" value="1" '.  $externalAdsEnabled . '/>
			</td>
			<th scope="col" style="width:1%;" nowrap>External URL</th>
			<td style="text-align:left">
				<i>' . get_site_url() . '/<input type="text" name="adUrlPrefix" value="' . $adUrlPrefix . '" />/your_campaign/
			</td>
		</tr>
		<tr class="gradient2">
			<td colspan="4">
				<div style="text-align:left !important;">
					If Google Analytics is enabled extra path information after the name of an ad campaign can be added to your analytics code as custom variables.
				</div>
			</td>
		</tr>
		<tr class="gradient2">
			<th scope="col" style="width:1%;" nowrap>Add Google Anayltic Variables</th>
			<td style="text-align:left" colspan="3">
				<input type="checkbox" name="gaVariablesEnabled" value="1" ' . $gaEnabled . ' '.  $gaVariablesEnabled . '/>
			</td>
		</tr>
		<tr><td colspan="4"></td></tr>
		<tr class="gradient2">
			<th scope="col" colspan="4" style="text-align:center;">Dashboard</th>
		</tr>
		<tr class="gradient2">
			<td colspan="4">
				<input type="checkbox" name="displayDashboard" value="1" '.  $displayDashboard . '/><label>Display Dashboard widget</label>
				<input type="checkbox" name="adsenseDashboard" value="1" ' . $adsenseDashboard . ' /><label>Add Adsense to Dashboard</label>
			</td>
		</tr>
		<tr><td colspan="4"><input type="submit" class="button" name="update" value="Update" /></td></tr>
	</tbody>
</table>' . "\n";

		return $content;
	}

	function GetCommissionJunctionAdminForm(){
		$content = "<span>Commission Junction integration still under development</span>";
		return $content;
	}

	function GetGoogleAnalyticsAdminForm(){
		$content = "<span>Google Anayltics integration still under development</span>";
		return $content;
	}

	function SettingsTab_view($tab, $action){
		$baseurl = $this->pageURL . '&tab=' . $tab . '&action=';
		echo '<form action="' . $baseurl . 'update" method="post">' . "\n";

		/** Panel for general settings */
		$groupOpen = true;
		$groupName = "General Settings";
		$groupContent = $this->GetGeneralSettingsAdminForm();
		$this->DisplaySettingsGroup($groupName, $groupContent, $groupOpen);

		/** Panel for Adsense settings */
		$groupOpen = true;
		$groupName = "Adsense Settings";
		$groupContent = $this->GetAdsenseAdminForm();
		$this->DisplaySettingsGroup($groupName, $groupContent, $groupOpen);

		/** Panel for Google Analytics settings */
		$groupOpen = false;
		$groupName = "Google Anayltics";
		$groupContent = $this->GetGoogleAnalyticsAdminForm();
		$this->DisplaySettingsGroup($groupName, $groupContent, $groupOpen);

		/** Panel for Commission Junction settings */
		$groupOpen = false;
		$groupName = "Commission Junction";
		$groupContent = $this->GetCommissionJunctionAdminForm();
		$this->DisplaySettingsGroup($groupName, $groupContent, $groupOpen);

		echo '</form>' . "\n";
    }

	function SettingsTab_update($tab, $action){
		//verify data
		$update = isset($_POST['update']);
		$reloadAdsenseAdsCache = isset($_POST['reload-adsense-ads-cache']);
		$reloadAdsenseStatsCache = isset($_POST['reload-adsense-stats-cache']);
		if ($reloadAdsenseAdsCache){
			if(isset($this->options['settings']['adsense']['username']) && isset($this->options['settings']['adsense']['password'])){
				$this->adsense->LoadAdUnits(true);
    	    	$this->adsense->Logout();
			}
		}

		if ($reloadAdsenseStatsCache){
			if(isset($this->options['settings']['adsense']['username']) && isset($this->options['settings']['adsense']['password'])){
				$this->adsense->LoadStats(true);
    	    	$this->adsense->Logout();
			}
		}

		if ($update){
			/** Update Adsense Settings */
			$this->options['settings']['adsense']['username'] = $_POST['adsenseUsername'];
			$this->adsense->SetUsername($this->options['settings']['adsense']['username']);
			if(isset($_POST['adsensePassword']) && strlen($_POST['adsensePassword']) > 1){
				$this->options['settings']['adsense']['password'] = $_POST['adsensePassword'];
				$this->adsense->SetPassword($this->options['settings']['adsense']['password']);
			}

			foreach($this->adsense->GetReportPeriods() as $key => $value){
				$this->options['settings']['adsense']['period'][$key] = isset($_POST['adsense_report_period_' . $key]);
			}

			foreach($this->adsense->GetReportTypes() as $key => $value){
				$this->options['settings']['adsense']['type'][$key] = isset($_POST['adsense_report_type_' . $key]);
			}

			foreach($this->adsense->GetAdCategories() as $key => $value){
				$this->options['settings']['adsense']['category'][$key] = isset($_POST['adsense_report_category_' . $key]);
			}

			if(isset($_POST['adsense-ads-cache-time'])){
				$this->options['settings']['adsense']['ads-cache'] = $_POST['adsense-ads-cache-time'];
				$this->adsense->SetAdsCache($_POST['adsense-ads-cache-time'] * 360);
			}

			if(isset($_POST['adsense-stats-cache-time'])){
				$this->options['settings']['adsense']['stats-cache'] = $_POST['adsense-stats-cache-time'];
				$this->adsense->SetStatsCache($_POST['adsense-stats-cache-time'] * 360);
			}

			/** Update General Settings */
			$this->options['settings']['fillEmptyAllocations'] = isset($_POST['fillEmptyAllocations']);
			if(isset($_POST['defaultsource']))
				$this->options['settings']['defaultsource'] = $_POST['defaultsource'];
	
			$this->options['settings']['displayDashboard'] = isset($_POST['displayDashboard']);
			$this->options['settings']['adsense']['dashboard'] = isset($_POST['adsenseDashboard']);

			$this->options['settings']['externalRulesUpdated'] = true;

			//if($this->options['settings']['externalAdsEnabled'] != isset($_POST['externalAdsEnabled'])){
			//	$this->options['settings']['externalRulesUpdated'] = true;
			//} else if($this->options['settings']['adUrlPrefix'] != $_POST['adUrlPrefix']){
			//	$this->options['settings']['externalRulesUpdated'] = true;
			//}else{
			//	$this->options['settings']['externalRulesUpdated'] = false;
			//}

			$this->options['settings']['externalAdsEnabled'] = isset($_POST['externalAdsEnabled']);
			$this->options['settings']['adUrlPrefix'] = $_POST['adUrlPrefix'];
			$this->options['settings']['analytics']['VariablesEnabled'] = isset($_POST['gaVariablesEnabled']);

			/** Save the updated settings */
			update_option($this->name . "_options", serialize($this->options));
		}

		//add to options
		$this->SettingsTab_view($tab, $action);
	}

	function DisplayHandbookSection($name, $content){
		//$ps = $open?'':'style="display:none;"';
		//$chevron = $open?'collapse.gif':'expand.gif';

		echo '<div class="settingspanel"><div class="settingspanelcaption" style="height:20px; cursor: pointer;" onclick="togglePannelAnimatedStatus(this.nextSibling, 50, 50)"><div style="float: left">' . $name . '</div><div style="float: right; vertical-align: middle"><img src="' . $this->imagePath . '/expand.gif" width="13" height="14" border="0" alt="Show/Hide" title="Show/Hide" /></div></div><div class="settingspanelcontent" style="display:none;">' . $content . '</div></div>' . "\n";

	}

	function MarkupHandbookSection($section){
		$content = '<div class="handbooksection">' . "\n";
		$content .= str_replace(array("\r\n", "\n", "\r"), '<br/>', $section);
		$content .= '</div>' . "\n";

		return $content;
	}

	function GetHandbookSections($path){
		$handbookText = file_get_contents($path, true);
		//split('= section =', $handbookText);

		$chunks = preg_split('/<-- ([^>]+) -->/i', $handbookText, -1, PREG_SPLIT_NO_EMPTY | PREG_SPLIT_DELIM_CAPTURE);

		$sections = array();
		for($i = 0; $i < count($chunks); $i++){
			$sections[$chunks[$i]] = $this->MarkupHandbookSection($chunks[$i + 1]);
			$i++;
		}

		return $sections;
	}

	function HandbookTab_view($tab, $action){

		$sections = $this->GetHandbookSections($this->handbookPath);
		foreach($sections as $name => $content){
			if(isset($name) && isset($content))
				$this->DisplayHandbookSection($name, $content);
		}
    }

	function AboutTab_view($tab, $action){
		echo '<H2><a href="http://wordpress.org/extend/plugins/advertwhirl">Advertwhirl version ' . $this->version . '</a></H2><br/>' . "\n";
		echo '<b>Advertwhirl</b> <i>(pronounced Adver-twhirl)</i> is a wordpress plugin that lets you set up advertising campaigns for your site.  Each campaign has 1 or more allocation strategies which can be made active manually or by schedule.  Each allocation strategy defines what ad-servers the campaign uses and how ads are rotated between them.  Campaigns can be accessed through a shortcode.<br/><br/>' . "\n";
		echo '<b>Example shortcode</b><br/>' . "\n";
		echo '<i>[­advertwhirl campaign=CAMPAIGN]</i><br/><br/>' . "\n";
		echo '&copy; Copyright 2011  Mobile Sentience LLC<br/>' . "\n";
		echo 'Written by <a href="mailto:oss@mobilesentience.com?subject=' . $this->name . ' version ' . $this->version . '">Max Jonathan Spaulding</a> - <a href="http://www.mobilesentience.com">Mobile Sentience LLC</a><br/>' . "\n";
		echo '<br/>' . "\n";
		echo 'This program is free software; you can redistribute it and/or modify<br/>' . "\n";
		echo 'it under the terms of the GNU General Public License as published by<br/>' . "\n";
		echo 'the Free Software Foundation; either version 2 of the License, or<br/>' . "\n";
		echo '(at your option) any later version.<br/>' . "\n";
		echo '<br/>' . "\n";
		echo 'This program is distributed in the hope that it will be useful,<br/>' . "\n";
		echo 'but WITHOUT ANY WARRANTY; without even the implied warranty of<br/>' . "\n";
		echo 'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br/>' . "\n";
		echo 'GNU General Public License for more details.<br/>' . "\n";
		echo '<br/>' . "\n";
		echo 'You should have received a copy of the GNU General Public License<br/>' . "\n";
		echo 'along with this program; if not, write to the Free Software<br/>' . "\n";
		echo 'Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA<br/><br/>' . "\n";
	}

	function SupportTab_view($tab, $action){
		$defaultSubject = 'Bug Report: ' . $this->name . ' Version ' . $this->version;
		$defaultMessage = "\n\n\n\n\n\n" . $this->GetTechnicalSpecs();

		include_once($this->libraryPath . "/captcha/shared.php");
		include_once($this->libraryPath . "/captcha/captcha_code.php");
		$wpf_captcha = new CaptchaCode();
		$wpf_code = wpf_str_encrypt($wpf_captcha->generateCode(6));

		echo '
<p><a href="http://www.mobilesentience.com">Mobile Sentience LLC</a> actively supports Advertwhirl if you have any questions or problems you can fill out the form below.  The message is pre-filled with some technical specs which will help us troubleshoot any issues.  <a href="http://www.mobilesentience.com">Mobile Sentience</a> provides all support through a public forum, this helps us manage our support costs as well as providing a searchable reference of past problems and questions that other users of encountered.  A great place to start if you have a simple question is to see if it has already been asked and answered on the <a href="http://www.mobilesentience.com/support/?mingleforumaction=viewforum&f=12.0">Advertwhirl Support Forum</a></p><br/>
<table class="widefat">
	<thead>
		<tr class="gradient">
			<th scope="col" colspan="2" style="text-align:center;">Report a problem</th>
		</tr>
	</thead>
	<tbody id="adsense-settings">
		<form action="http://www.mobilesentience.com/wp-content/plugins/mingle-forum/wpf-insert.php" name="addform" method="post" target="_blank">
		<tr class="gradient2">
			<th>Subject</th>
			<td><input style="width:99%;" type="text" name="add_topic_subject" value="' . $defaultSubject . '"></td>
		</tr>
		<tr class="gradient2">
			<th valign="top" >Message</th>
			<td><textarea rows="20" cols="80" name="message" >' . $defaultMessage . '</textarea></td>
		</tr>
		<tr class="gradient2">
			<th>Security Code</th>
			<td>
				<img alt="" src="http://www.mobilesentience.com/wp-content/plugins/mingle-forum/captcha/captcha_images.php?width=120&amp;height=40&amp;code=' . $wpf_code . '">
				<input type="hidden" name="wpf_security_check" value="' . $wpf_code . '">
				<input id="wpf_security_code" name="wpf_security_code" type="text">
			</td>
		<tr>
			<td colspan="2" align="center"><input type="submit" id="wpf-post-submit" name="add_topic_submit" value="Submit" class="button"></td>
			<input type="hidden" name="add_topic_forumid" value="12">
			<input type="hidden" name="add_topic_plink" value="http://www.mobilesentience.com/support/">
		</tr>
		</form>
	</tbody>
</table>' . "\n";

	}

	function getRightMost($sSrc, $sSrch) { 
		for ($i = strlen($sSrc); $i >= 0; $i = $i - 1) {
			$f = strpos($sSrc, $sSrch, $i);
			if ($f !== FALSE) {
				return substr($sSrc,$f + strlen($sSrch), strlen($sSrc));
			}
		}
		return $sSrc;
	}

	public function DisplayAdminTabs($activeTab){
		echo '<div class="tabBox" style="clear:both;">' . "\n";
		echo '	<div class="tabArea">' . "\n";
		foreach(array_keys($this->AdminTabs) as $tab){
			$url = $this->pageURL . "&tab=" . $tab;
			if($activeTab == $tab){
				echo '<a class="activetab" href="' . $url . '">' . $this->AdminTabs[$tab]['name'] . '</a>' . "\n";
			}else{
				echo '<a class="tab" href="' . $url . '">' . $this->AdminTabs[$tab]['name'] . '</a>' . "\n";
			}
		}
		echo '	</div>' . "\n";
	}

	public function DisplayAdminContent($tab, $action){
		echo '<div class="tabMain">' . "\n";
		echo '<div class="tabContent" id="tabContent" >' . "\n";
		if(isset($this->AdminTabs[$tab])){
			$func = $this->AdminTabs[$tab]['method_base'] . "_" . $action;
			if(!method_exists($this, $func)){
				$func = $this->AdminTabs[$tab]['method_base'] . "_view";
			}
			if(method_exists($this, $func)){
				call_user_func(array(&$this, $func), $tab, $action);
			}
		}
		echo '</div>' . "\n";
		echo '</div>' . "\n";
		echo '</div>' . "\n";
	}

	// Create the administration panel
	public function CreateAdminPanel(){

		$activeTab = "campaigns-tab";
		if(isset($_GET['tab'])){
			if(isset($this->AdminTabs[$_GET['tab']])){
				$activeTab =  $_GET['tab'];
			}
		}

		$action = "view";
		if(isset($_GET['action'])){
			$action =  $_GET['action'];
		}

		$this->DisplayMobileSentienceAd();
		$this->DisplayAdminBanner($activeTab);
		$this->DisplayAdminTabs($activeTab);
		$this->DisplayAdminContent($activeTab, $action);
    }    

}
?>
