<?php
/*
Copyright 2011  Mobile Sentience LLC  (email : oss@mobilesentience.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
                                                                 
*/


if(!function_exists('VerifyRule_author')){
	function VerifyRule_author($rule){
		if(!isset($rule['author']))
			return false;
		global $wp_version;
		if ($wp_version > "2.8")
			return $rule['author'] === get_the_author_meta('ID');
	 	return $rule['author'] === get_the_author_ID();
	}
}

if(!function_exists('VerifyRule_posttype')){
	function VerifyRule_posttype($rule){
		if(!isset($rule['posttype']))
			return false;
	 	return $rule['posttype'] === get_post_type();
	}
}

if(!function_exists('VerifyRule_getargument')){
	function VerifyRule_getargument($rule){
		// 'argname' => 'alruleargumentname-',
		// 'argvalue' => 'alruleargumentvalue-',
		// 'argop' => 'alruleargumentoperator-'


		// Verify that we have all the arguments that we need and that the GET argument is set
		if(!isset($rule['argname']) || !isset($rule['argvalue']) || !isset($rule['argop']) || !isset($_GET[$rule['argname']]))
			return false;

		switch($rule['argop']){
			case '=': // is equal to
				return $_GET[$rule['argname']] == $rule['argvalue'];
				break;
			case '!=': // is not equal to
				return $_GET[$rule['argname']] != $rule['argvalue'];
				break;
			case '>': // is greater than
				if(is_numeric($rule['argvalue'])){
					return $_GET[$rule['argname']] > $rule['argvalue'];
				}else{
					return strcmp($_GET[$rule['argname']], $rule['argvalue']) > 0;
				}
				break;
			case '<': // is less than
				if(is_numeric($rule['argvalue'])){
					return $_GET[$rule['argname']] < $rule['argvalue'];
				}else{
					return strcmp($_GET[$rule['argname']], $rule['argvalue']) < 0;
				}
				break;
			case '>=': // is greater than or equal to
				if(is_numeric($rule['argvalue'])){
					return $_GET[$rule['argname']] >= $rule['argvalue'];
				}else{
					return strcmp($_GET[$rule['argname']], $rule['argvalue']) >= 0;
				}
				break;
			case '<=': // is less than or equal to
				if(is_numeric($rule['argvalue'])){
					return $_GET[$rule['argname']] <= $rule['argvalue'];
				}else{
					return strcmp($_GET[$rule['argname']], $rule['argvalue']) <= 0;
				}
				break;
			case '~': // matches regular expression
				return preg_match('/' . $rule['argvalue'] . '/', $rule['argname'], $matches);
				break;
			case '!~': // does not match regular expression
				return !preg_match('/' . $rule['argvalue'] . '/', $rule['argname'], $matches);
				break;
		}

	 	return false;
	}
}

